#pragma once

#include <stdio.h>
#include <stdint.h>
#include <sys/param.h>
#ifdef __cplusplus 
extern "C" {
#endif

#if __FreeBSD_version < 1301000
#error libbsdtopo only works on FreeBSD 13.1 and later
#endif

struct topo_desc;

int
topo_num_core(void);

int
topo_num_numa(void);

int
topo_core_to_numa(int coreid);

void
topo_destroy(void);

int
topo_init(int verbose);

uint64_t
topo_uptime_ns(void);

#ifdef __cplusplus 
} // extern "C"
#endif
